#! /usr/bin/python3
# -*- coding: utf-8 -*-

from tkinter import *

fenetre=Tk()
fenetre.title("tkinter")
fenetre.configure(bg='beige',width=260,height=80)
fenetre.pack_propagate(0)
fenetre.resizable(width=FALSE, height=FALSE)

lNombre=Label(fenetre,text="Nombre :",bg='beige')
lNombre.grid(column=0,row=0)

rEntry=Entry(fenetre,width=6)
rEntry.grid(column=0,row=1)

def bin2dec(b):
      d=0
      l=list(b)
      l.reverse()
      for i in range(len(l)):
          d+=int(l[i])*(2**i)
      return d

def dec2bin(d):
    Q=int(d)
    b=''
    while Q!=0:
        R=Q%2
        Q=Q//2
        b=str(R)+b
    return b

lResultat=Label(fenetre,text="Résultat :",bg='beige')
lResultat.grid(column=1,row=0)

def cDec2bin():
    x=rEntry.get()
    b=dec2bin(x)
    lConversion.config(text=b)
    fenetre.pack_propagate(1)

def keydec2bin(evt):
    x=rEntry.get()
    cDec2bin()
    rEntry.delete(0,END)
    rEntry.insert(0,x)

def cBin2dec():
    x=rEntry.get()
    rEntry.delete(0,END)
    rEntry.insert(0,x)
    d=bin2dec(x)
    lConversion.config(text=str(d))
    fenetre.pack_propagate(1)

def keybin2dec(evt):
    cBin2dec()

cButton=Button(fenetre,text="Décimal vers binaire",bg='beige',command=cDec2bin)
cButton.grid(column=0,row=2)

dButton=Button(fenetre,text="Binaire vers décimal",bg='beige',command=cBin2dec)
dButton.grid(column=0,row=3)

rEntry.bind("<d>",keydec2bin)
rEntry.bind("<End>",keybin2dec)

lConversion=Label(fenetre,text="",bg='beige')
lConversion.grid(column=1,row=1,rowspan=1)

qButton=Button(fenetre,text="Quitter",bg='beige',command=fenetre.destroy)
qButton.grid(column=0,row=4,columnspan=2)

fenetre.mainloop()
