#!/usr/bin/python3
# -*- coding: utf-8 -*-

from tkinter import *

fenetre=Tk()
fenetre.title("Conversion")
fenetre.configure(bg='skyblue')
fenetre.resizable(width=FALSE, height=FALSE)

lNombre=Label(fenetre,text="Nombre :",bg='skyblue')
lNombre.grid(column=0,row=0)

rEntry=Entry(fenetre,width=16)
rEntry.grid(column=0,row=1)

def bin2dec(nBin):
    nDec=0
    puis2=1
    while nBin!=0:
        c=nBin%10
        nDec=nDec+c*puis2
        nBin=(nBin-c)//10
        puis2=2*puis2
    return nDec

def dec2bin(nDec):
    nBin=0
    puis10=1
    while nDec!=0:
        c=nDec%2
        nBin=nBin+c*puis10
        nDec=nDec//2
        puis10=10*puis10
    return nBin

lResultat=Label(fenetre,text="Résultat (taper Entrée) :",bg='skyblue')
lResultat.grid(column=1,row=0)

def cDec2bin():
    x=rEntry.get()
    if x.isnumeric():
      b=dec2bin(int(x))
      lConversion.config(text=str(b))
    else:
      lConversion.config(text="Erreur en entrée")

def cBin2dec():
    x=rEntry.get()
    if (x.count('1')+x.count('0')==len(x) and len(x)>0):
      d=bin2dec(int(x))
      lConversion.config(text=str(d))
    else:
      lConversion.config(text="Erreur en entrée")

mod = 1

def changeconversion():
  global mod
  global conversionBoutton
  if mod==1:
    mod=2
    text="binaire à décimal"
  else:
    mod=1
    text="décimal à binaire"
  conversionBoutton.config(text=text)

modeLabel=Label(fenetre,text="Mode (shift) :",bg='skyblue')
modeLabel.grid(column=0,row=2,columnspan=2)
conversionBoutton=Button(fenetre,text="décimal à binaire",bg='skyblue',command=changeconversion)
conversionBoutton.grid(column=0,row=3,columnspan=2)

def lanceconversion():
  global mod
  if mod==1:
    cDec2bin()
  else:
    cBin2dec()

rEntry.focus()
    
rEntry.bind("<Return>",lambda evt:lanceconversion())
rEntry.bind("<KP_Enter>",lambda evt:lanceconversion())

rEntry.bind("<Shift_L>",lambda evt:changeconversion())
rEntry.bind("<Shift_R>",lambda evt:changeconversion())

rEntry.bind("<Escape>",lambda evt:fenetre.destroy())


lConversion=Label(fenetre,text="",bg='skyblue')
lConversion.grid(column=1,row=1)
qButton=Button(fenetre,text="Quitter",bg='skyblue',command=fenetre.destroy)
qButton.grid(column=0,row=4,columnspan=2)
fenetre.mainloop()
