from tkinter import *

class Carte(Canvas):

    def __init__(self,parent,params,matrice,**kwargs):
        Canvas.__init__(self,parent,width=params.largeur_fenetre+params.grosseur_ligne,
                        height=params.largeur_fenetre+params.grosseur_ligne,
                        bg="white",bd=0,**kwargs)
        self.n=params.largeur_carte
        self.l=params.largeur_fenetre
        self.c=self.l/self.n
        self.b=params.grosseur_ligne
        self.couleur=params.couleur
        c,b,n=self.c,self.b,self.n
        self.rep=[[self.create_rectangle(x*c+b,y*c+b,(x+1)*c+b,(y+1)*c+b,fill=self.couleur[matrice[x][y]],width=b,outline='gray') for y in range(n)] for x in range(n)]
        self.pack()
        self.master.resizable(width=FALSE, height=FALSE)
        
    def set_carte(self,matrice):
        for x in range(self.n):
            for y in range(self.n):
                self.itemconfig(self.rep[x][y],fill=self.couleur[matrice[x][y]])

    def change_parcelle(self,x,y,v):
        self.itemconfig(self.rep[x][y],fill=self.couleur[v])

    def get_xy(self,event):
        x=int((event.x-self.b)/self.c)
        y=int((event.y-self.b)/self.c)
        return x,y
