#! /usr/bin/python3
# -*- coding: utf-8 -*-
#
# Version : 0.1 (décembre 2015)

####################################
#                                  #
#             Plateau              #
#                                  #
#    création en décembre 2015     #
#                                  #
####################################

from tkinter import *

from Params import Parametres
from Carte import Carte

if __name__ == '__main__':

    wcarte = Tk() #
    wcarte.config(bg='white') #
    wcarte.title('Plateau') #
    wcarte.resizable(width=FALSE, height=FALSE) #

    params=Parametres()

    lb_joueur=Label(wcarte,bg="white") #

    def echange_valeur(x,y): #

        valeur_actuelle=matrice[x][y] #
        if valeur_actuelle==0:
            nouvelle_valeur=1 #
        else:
            nouvelle_valeur=0 #
        matrice[x][y]=nouvelle_valeur #
        carte.change_parcelle(x,y,matrice[x][y]) #

    def change_joueur(): # Note : Les numéros de joueurs (hors affichage) sont 0 et 1

        global joueur

        joueur=1-joueur #
        lb_joueur.config(text="Joueur "+str(joueur+1)) #

    def action(evt):

        x,y=carte.get_xy(evt) #
        echange_valeur(x,y) #

        change_joueur()

    def init(): #

        global joueur,carte,matrice

        for widget in wcarte.winfo_children(): # Recherche les éléments de la fenêtre de jeu
            widget.pack_forget() # 

        matrice=[[0 for y in range(params.largeur_carte)]
                 for x in range(params.largeur_carte)] #

        joueur=0 # Joueur 1 commence

        lb_joueur.config(text="Joueur "+str(joueur+1))
        lb_joueur.pack()

        carte=Carte(wcarte,params,matrice) # Crée et place le plateau de jeu appelé carte
        carte.focus_set() #

        carte.bind("<Button-1>",action) #

    init() #

    wcarte.mainloop() #
