#! /usr/bin/python3
# -*- coding: utf-8 -*-

from tkinter import *

fenetre=Tk()
fenetre.title("Conversion")
fenetre.configure(bg='beige')
fenetre.resizable(width=FALSE, height=FALSE)

def decimalBase(nDec,base):
    nBase=0
    puis10=1
    while nDec!=0:
        c=nDec%base
        nBase=nBase+c*puis10
        nDec=nDec//base
        puis10=10*puis10
    return nBase

def baseDecimal(nBase,base):
    nDec=0
    puisBase=1
    puis10=10
    while nBase!=0:
        c=nBase%10
        nDec=nDec+c*puisBase
        nBase=(nBase-c)//10
        puisBase=base*puisBase
    return nDec

def DecimalVersBinaire():
    ndec=int(entry_nombre.get())
    nbin=decimalBase(ndec,2)
    label_res.config(text=str(nbin))

def BinaireVersDecimal():
    nbin=int(entry_nombre.get())
    ndec=baseDecimal(nbin,2)
    label_res.config(text=str(ndec))

lNombre=Label(fenetre,text="Nombre :",bg='beige')
lNombre.grid(column=0,row=0)

entry_nombre=Entry(fenetre,width=6)
entry_nombre.grid(column=0,row=1)

label_resultat=Label(fenetre,text="Résultat :",bg='beige')
label_resultat.grid(column=1,row=0)

label_res=Label(fenetre,text="",bg='beige')
label_res.grid(column=1,row=1)

bButton=Button(fenetre,text="Décimal vers binaire",bg='beige',command=DecimalVersBinaire)
bButton.grid(column=0,row=2)
dButton=Button(fenetre,text="Binaire vers décimal",bg='beige',command=BinaireVersDecimal)
dButton.grid(column=0,row=3)

qButton=Button(fenetre,text="Quitter",bg='beige',command=fenetre.destroy)
qButton.grid(column=0,row=4,columnspan=2)
fenetre.mainloop()
