#!/usr/bin/python3
# -*- coding: utf-8 -*-

from tkinter import *

def miroir(nombre):
    return str(nombre)[::-1]

def baseDecimal(nBase,base):
    chiffres='0123456789ABCDEF'
    nDec=0
    puisBase=1
    chaine=str(nBase)
    l=len(chaine)
    for v in range(l):
        i=chaine[l-v-1]
        k=chiffres.find(i)
        nDec=nDec+k*puisBase
        puisBase=puisBase*base
    return nDec
        
def decimalBase(nDec,base):
    chiffres='0123456789ABCDEF'
    nBase=''
    while nDec!=0:
        c=nDec%base
        nBase=chiffres[c]+nBase
        nDec=nDec//base
    return nBase
    
def baseBase(nBase,baseInitiale,baseFinale):
    return decimalBase(baseDecimal(nBase,baseInitiale),baseFinale)

def baseBaseUSE():

    sbaseinit=ebaseinit.get()
    sbasefin=ebasefin.get()
    
    text_resultat=""

    if sbaseinit.isnumeric() and sbasefin.isnumeric():
        baseinit=int(sbaseinit)

        if baseinit<=16 and baseinit>=2:

            snombreinit=enombreinit.get()
            chiffres='0123456789ABCDEF'[0:baseinit]
            verif=True
            for k in str(snombreinit):
                if k not in chiffres:
                    verif=False
                    break

            if verif:
                basefin=int(sbasefin)
                if basefin<=16 and basefin>=2:
                    text_resultat=baseBase(snombreinit,baseinit,basefin)
                else:
                    text_resultat="Erreur ! Ne prend pas la base "+sbasefin
            else:
                text_resultat="Erreur ! Mauvaise base"
        else:
            text_resultat="Erreur ! Ne prend pas la base "+sbaseinit
    else:
        text_resultat="Erreur ! Mauvaise base"
    lresultat.config(text=text_resultat)

def converter(evt):
    baseBaseUSE()

fenetre=Tk()
fenetre.title("Convertisseur")

fenetre.configure(bg='green')
fenetre.resizable(width=FALSE,height=FALSE)

lnombreinit=Label(fenetre,text ="Nombre initial :",bg='green')
lnombreinit.grid(column=0,row=0,columnspan=2)

enombreinit=Entry(fenetre,text="", width =16)
enombreinit.grid(column=0,row=1,columnspan=2)

ltextres=Label(fenetre,text ="Résultat final :",bg='green')
ltextres.grid(column=2,row=0)

lresultat=Label(fenetre,text="",bg='green')
lresultat.grid(column=2,row=1)

lbaseinit=Label(fenetre,text ="Base initiale :",bg='green')
lbaseinit.grid(column=0,row=2)

ebaseinit=Entry(fenetre,text="",width =4)
ebaseinit.grid(column=1,row=2)

lbasefin=Label(fenetre,text ="Base finale :",bg='green')
lbasefin.grid(column=0,row=3)
    
ebasefin=Entry(fenetre,text="",width =4)
ebasefin.grid(column=1,row=3)
    
bconvert=Button(fenetre,text="Convertir",bg='red',width=10,command=baseBaseUSE)
bconvert.grid(column=2,row=2)

bquitter=Button(fenetre,text="Quitter",bg='red',width=10,command=fenetre.destroy)
bquitter.grid(column=2,row=3)

enombreinit.bind("<Return>",lambda evt:baseBaseUSE())
ebaseinit.bind("<Return>",lambda evt:baseBaseUSE())
ebasefin.bind("<Return>",lambda evt:baseBaseUSE())

fenetre.mainloop()
